/*******************************************************************

   ModuleEntry.c

*********************************************************************/

#include "includes/Project.h"


ModuleInfo module_info =
{
    MODULE_VER_NUMBER,
    MODULE_NAME,
    MODULE_CATALOG,
    MODULE_FLAGS,
    MODULE_FUNC_COUNT,

    { FUNC0_ID, COMMAND_0, FUNC0_DESCRIPTION, FUNC0_FLAGS, FUNC0_TEMPLATE }
};


#if MODULE_FUNC_COUNT-1

ModuleFunction module_func[MODULE_FUNC_COUNT-1] =
{ 
    { FUNC1_ID, COMMAND_1, FUNC1_DESCRIPTION, FUNC1_FLAGS, FUNC1_TEMPLATE },
    { FUNC2_ID, COMMAND_2, FUNC2_DESCRIPTION, FUNC2_FLAGS, FUNC2_TEMPLATE }
};

#endif


static char version[] = "\0$VER: " VERSION_STRING "\0";

/********************************************************************/

int __asm __saveds L_Module_Entry( register __a0 char *args,              
                                   register __a1 struct Screen *screen,   
                                   register __a2 IPCData *ipc,
                                   register __a3 IPCData *main_ipc,
                                   register __d0 ULONG mod_id,
                                   register __d1 EXT_FUNC(func_callback) )
{               
    DOExchange( args, screen, ipc );

    return 1;
}
