/*******************************************************************

   Project.h

   Now I do some less comments, since here is starting the average
   level :).

*********************************************************************/

#include <dos.h>

#include <proto/dos.h>
#include <proto/asl.h>
#include <proto/exec.h>
#include <proto/layers.h>
#include <proto/utility.h>
#include <proto/gadtools.h>
#include <proto/graphics.h>
#include <proto/intuition.h>
#include <proto/commodities.h>

#include <dos/exall.h>
#include <dos/dostags.h>
#include <exec/memory.h>
#include <exec/execbase.h>
#include <graphics/rpattr.h>

#define  CATCOMP_NUMBERS
#include "includes/buildin.strings"

#define  _DOPUS_MODULE_DEF
#include <dopus/modules.h>

#define  SDI_TO_ANSI
#include "/sc/include/sdi_std.h"

/********************************************************************/

#define MODULE_NAME        "doexchange.module"
#define MODULE_VER_NUMBER  1
#define MODULE_CATALOG     "doexchange.catalog"
#define MODULE_FLAGS       0
#define MODULE_FUNC_COUNT  1

#define VERSION_STRING     MODULE_NAME " 1.0 " __AMIGADATE__


#define COMMAND_0          "DOExchange"
#define FUNC0_ID           0
#define FUNC0_FLAGS        0
#define FUNC0_TEMPLATE     "Hide/S,Show/S,BGC=BackgroundColour/N,TC=TextColour/N,N=NewName/K,Quit/S"

#define TEMPLATE_COUNT     6

/********************************************************************/
// externals from modinit.c
extern APTR mempool;
extern IPCData *exchange;

// our "main" function
extern void DOExchange( STRPTR args, struct Screen *screen, IPCData *ipc );

